﻿--[[ Inspired by yleaf's FogBG located at http://www.wowinterface.com/downloads/info12518-FogBG.html ]]--

--local AuraFrame = CreateFrame("Model", nil, UIParent)
local AuraFrame = CreateFrame("PlayerModel", nil, UIParent)
local config = CreateFrame("Frame")
local height = GetScreenHeight()
local tip = GameTooltip
local red = "SPELLS\\RedRadiationFog.m2"
--local red = "Interface\\AddOns\\AmbientAura\\Redradiationfog.m2"
local blue = "SPELLS\\BlueRadiationFog.m2"
local green = "SPELLS\\GreenRadiationFog.m2"

local defaults = {
	hmult = 1,
	--alpha = 1,
	alpha = .5,
--	scale = 1,
	usage = 1,
}
local values = {
	"Combat/Resting",
	"Warrior stances",
	"Death Knight auras",
	"Red fog always",
	"Blue fog always",
	"Green fog always",
}

local function SetUpModel()
	AuraFrame:SetHeight(height * AmbientAuraDB.hmult)  -- place for variable
	AuraFrame:SetAlpha(AmbientAuraDB.alpha)  -- place for variable
--	AuraFrame:SetModelScale(AmbientAuraDB.scale)
	AuraFrame:SetCamDistanceScale(2.5)
	AuraFrame:SetPosition(0,0,-2)
end

--white:26691, green:17055, purple:17054, fire:30903, yellow:17286, red:17522
--blue:18075, pink:20262, orange:20382, violet:20383, 

local function SetUpEvents()
	local usage = AmbientAuraDB.usage
	if usage == 1 then
		if IsResting() then
			--AuraFrame:SetModel(green)
			AuraFrame:SetDisplayInfo(17055)
		elseif InCombatLockdown() then
			--AuraFrame:SetModel(red)
			AuraFrame:SetDisplayInfo(17522)
		else
			--AuraFrame:SetModel(blue)
			AuraFrame:SetDisplayInfo(18075)
		end
		AuraFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
		AuraFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
		AuraFrame:RegisterEvent("PLAYER_UPDATE_RESTING")
		AuraFrame:UnregisterEvent("UPDATE_SHAPESHIFT_FORM")
	elseif usage == 2 or usage == 3 then
		local active,stance,_
		for i=1,3 do
			_,_,active = GetShapeshiftFormInfo(i)
			if active == 1 then
				stance = i
				break
			end
		end
		if stance == 1 then
			--AuraFrame:SetModel(red)
			AuraFrame:SetDisplayInfo(17522)
		elseif stance == 2 then
			--AuraFrame:SetModel(blue)
			AuraFrame:SetDisplayInfo(18075)
		elseif stance == 3 then
			--AuraFrame:SetModel(green)
			AuraFrame:SetDisplayInfo(17055)
		end
		AuraFrame:UnregisterEvent("PLAYER_REGEN_DISABLED")
		AuraFrame:UnregisterEvent("PLAYER_REGEN_ENABLED")
		AuraFrame:UnregisterEvent("PLAYER_UPDATE_RESTING")
		AuraFrame:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
	else
		if usage == 4 then
			--AuraFrame:SetModel(red)
			AuraFrame:SetDisplayInfo(17522)
		elseif usage == 5 then
			--AuraFrame:SetModel(blue)
			AuraFrame:SetDisplayInfo(18075)
		elseif usage == 6 then
			--AuraFrame:SetModel(green)
			AuraFrame:SetDisplayInfo(17055)
		end
		AuraFrame:UnregisterEvent("PLAYER_REGEN_DISABLED")
		AuraFrame:UnregisterEvent("PLAYER_REGEN_ENABLED")
		AuraFrame:UnregisterEvent("PLAYER_UPDATE_RESTING")
		AuraFrame:UnregisterEvent("UPDATE_SHAPESHIFT_FORM")
	end
end

local function OnEnter(self, text)
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT")
	GameTooltip:SetText(text)
	GameTooltip:Show()
end

local function AddOptions()
	--CREATE BLIZZ OPTIONS--
	local header = config:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
		header:SetParent(config)
		header:SetPoint("TOPLEFT", config, "TOPLEFT", 20,-15)
		header:SetText("AmbientAura")
	local subheader = config:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
		subheader:SetParent(config)
		subheader:SetPoint("TOPLEFT", header, "BOTTOMLEFT", 0,-10)
		subheader:SetPoint("RIGHT", config, "RIGHT", -20,0)
		subheader:SetHeight(30)
		subheader:SetNonSpaceWrap(true)
		subheader:SetJustifyH("LEFT")
		subheader:SetText("Creates a swirly fog effect along the bottom of your screen, colored by combat/resting status.")
	local hslider = CreateFrame("Slider", nil, config, "OptionsSliderTemplate")
		hslider:SetMinMaxValues(.25,2)
		hslider:SetPoint("TOPLEFT", subheader, "BOTTOMLEFT", 0, -35)
		hslider:SetValueStep(.1)
		hslider:SetValue(AmbientAuraDB.hmult)  -- place for variable (current value)
		hslider:SetScript("OnValueChanged", function(_,val) AmbientAuraDB.hmult = val SetUpModel() end)
		hslider:SetScript("OnEnter", function(self) OnEnter(self,"Set the height of the fog on your screen.") end)
		hslider:SetScript("OnLeave", function() GameTooltip:Hide() end)
	local htext = hslider:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		htext:SetParent(config)
		htext:SetPoint("BOTTOM", hslider, "TOP", 0,5)
		htext:SetText("Fog Height")
	local aslider = CreateFrame("Slider", nil, config, "OptionsSliderTemplate")
		aslider:SetMinMaxValues(.1,1)
		aslider:SetPoint("LEFT", hslider, "RIGHT", 30, 0)
		aslider:SetValueStep(.05)
		aslider:SetValue(AmbientAuraDB.alpha)  -- place for variable (current value)
		aslider:SetScript("OnValueChanged", function(_,alpha) AmbientAuraDB.alpha = alpha SetUpModel() end)
		aslider:SetScript("OnEnter", function(self) OnEnter(self,"Set the alpha of the fog on your screen.") end)
		aslider:SetScript("OnLeave", function() GameTooltip:Hide() end)
	local atext = hslider:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		atext:SetParent(config)
		atext:SetPoint("BOTTOM", aslider, "TOP", 0,5)
		atext:SetText("Fog Alpha")
	local tkDrop = LibStub("tekKonfig-Dropdown")
	local dropdown,droptext,dropcont,droplabel = tkDrop.new(config,"Usage","TOPLEFT", hslider, "BOTTOMLEFT", 0,-15)
--		dropdown:SetPoint("TOPLEFT", hslider, "BOTTOMLEFT", -15,-40)
		dropdown:SetWidth(175)
		droplabel:ClearAllPoints()
		droplabel:SetPoint("BOTTOMLEFT", dropdown, "TOPLEFT", 20, 5)
		dropdown.tiptext = "Select how Ambient Aura should display its colors for this character."
		droptext:SetText(values[AmbientAuraDB.usage])
		UIDropDownMenu_SetSelectedValue(dropdown, AmbientAuraDB.usage)
		local function OnClick(self)
			UIDropDownMenu_SetSelectedValue(dropdown, self.value)
			droptext:SetText(values[self.value])
			AmbientAuraDB.usage = self.value
			SetUpEvents()
		end
		UIDropDownMenu_Initialize(dropdown, function()
			local current, info = UIDropDownMenu_GetSelectedValue(dropdown), UIDropDownMenu_CreateInfo()
			for k,v in pairs(values) do
				info.text, info.value, info.func, info.checked = v, k, OnClick, v == current
				UIDropDownMenu_AddButton(info)
			end
		end)
--[[	local sslider = CreateFrame("Slider", nil, config, "OptionsSliderTemplate")
		sslider:SetMinMaxValues(.1,2)
		sslider:SetPoint("TOPLEFT", hslider, "BOTTOMLEFT", 0, -35)
		sslider:SetValueStep(.05)
		sslider:SetValue(AmbientAuraDB.scale)  -- place for variable (current value)
		sslider:SetScript("OnValueChanged", function(_,scale) AmbientAuraDB.scale = scale SetUpModel() end)
		sslider:SetScript("OnEnter", function(self) OnEnter(self,"Set the scale of the fog model on your screen.") end)
		sslider:SetScript("OnLeave", function() GameTooltip:Hide() end)
--		sslider:Disable()
	local stext = sslider:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		stext:SetParent(config)
		stext:SetPoint("BOTTOM", sslider, "TOP", 0,5)
		stext:SetText("Fog Scale")
--		stext:SetTextColor(.7,.7,.7)]]
end

local function Initialize()
	--SAVED VARIABLES--
	AmbientAuraDB = AmbientAuraDB or {}
	for k,v in pairs(defaults) do
	    if type(AmbientAuraDB[k]) == "nil" then
	        AmbientAuraDB[k] = v
	    end
	end

	--SLASH COMMANDS / ADD TO BLIZZ--
	SlashCmdList["AMBIENTAURA"] = function() InterfaceOptionsFrame_OpenToCategory("AmbientAura") end
	SLASH_AMBIENTAURA1 = "/ambientaura"
	SLASH_AMBIENTAURA2 = "/aa"
	config.name = "AmbientAura"
	InterfaceOptions_AddCategory(config)
	AddOptions()
	
	--INITIAL MODEL SETUP--
	AuraFrame:SetPoint("BOTTOM", UIParent)
	--AuraFrame:SetPoint("CENTER", UIParent, "BOTTOM")
	AuraFrame:SetWidth(GetScreenWidth())
--	AuraFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
--	AuraFrame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
	AuraFrame:SetFrameStrata("BACKGROUND")
	SetUpModel()
	SetUpEvents()
end

AuraFrame:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_LOGIN" then
		Initialize()
		AuraFrame:UnregisterEvent("PLAYER_LOGIN")
	elseif event == "PLAYER_REGEN_DISABLED" then
		--AuraFrame:SetModel(red)
		AuraFrame:SetDisplayInfo(17522)
	elseif event == "PLAYER_REGEN_ENABLED" then
		--AuraFrame:SetModel(blue)
		AuraFrame:SetDisplayInfo(18075)
	elseif event == "PLAYER_UPDATE_RESTING" then
		if IsResting() then
			--AuraFrame:SetModel(green)
			AuraFrame:SetDisplayInfo(17055)
		else
			--AuraFrame:SetModel(blue)
			AuraFrame:SetDisplayInfo(18075)
		end
	elseif event == "UPDATE_SHAPESHIFT_FORM" then
		local active,stance,_
		for i=1,3 do
			_,_,active = GetShapeshiftFormInfo(i)
			if active == 1 then
				stance = i
				break
			end
		end
		if stance == 1 then
			--AuraFrame:SetModel(red)
			AuraFrame:SetDisplayInfo(17522)
		elseif stance == 2 then
			--AuraFrame:SetModel(blue)
			AuraFrame:SetDisplayInfo(18075)
		elseif stance == 3 then
			--AuraFrame:SetModel(green)
			AuraFrame:SetDisplayInfo(17055)
		end
	end
end)

--AuraFrame:SetScript("OnAnimFinished", function(self) self:SetSequence(0) end)	--loops models that do not do so automatically
AuraFrame:RegisterEvent("PLAYER_LOGIN")

--[[	ADDITIONAL MODELS
AuraFrame:SetModel("PARTICLES\\Bubbles.m2")	--string of bubbles rising
AuraFrame:SetModel("PARTICLES\\Lootfx.m2")		--sparklies
AuraFrame:SetModel("PARTICLES\\Morphfx.m2")	--druid rejuv graphic (though a little annoying)
AuraFrame:SetModel("SPELLS\\ChristmasSnowRain.m2")	--snow
AuraFrame:SetModel("SPELLS\\Druid_Starfallstate.m2")	--flashing moon with shooting stars
AuraFrame:SetModel("SPELLS\\FaerieFire.m2")	--shiny gold butterflies
AuraFrame:SetModel("PARTICLES\\Loginfx.m2")	--flashes of light from below
AuraFrame:SetModel("SPELLS\\Abolishmagic_base.m2")	--colorful swirly star
AuraFrame:SetModel("SPELLS\\Abyssal_ball.m2")	--fast swirly brownish fog
AuraFrame:SetModel("SPELLS\\Abyssal_impact_base.m2")	--pulsing bars of light
AuraFrame:SetModel("SPELLS\\Achievement_onroot.m2")	--swirly colorful stars/bubbles
AuraFrame:SetModel("SPELLS\\Acidliquidbreath.m2")	--bubbly acid
AuraFrame:SetModel("SPELLS\\Acidliquidbreath_purple.m2")	--blue/purple version
AuraFrame:SetModel("SPELLS\\Acidliquidbreathred.m2")	--reddish/orange version
AuraFrame:SetModel("SPELLS\\Amplifymagic_impact_base.m2")	--orange/red stripes of light
AuraFrame:SetModel("SPELLS\\Arcane_form_precast.m2")	--purplish fire
AuraFrame:SetModel("SPELLS\\Arcanebreath.m2")	--blue bubbly mist
AuraFrame:SetModel("SPELLS\\Arcaneforceshield_blue.m2")	--blue shield with flash and runes
AuraFrame:SetModel("SPELLS\\Archimonde_blue_fire.m2")	--blue bubbly mist (diff from arcane one)
AuraFrame:SetModel("SPELLS\\Archimonde_fire.m2")		--red one
AuraFrame:SetModel("SPELLS\\Camouflage_base.m2")		--swirling autumn leaves	(doesn't loop)
AuraFrame:SetModel("SPELLS\\Chargetrail.m2")		--twinkling red lights
AuraFrame:SetModel("WORLD\\Generic\\human\\passive doodads\\fog\\sfx_fog_nasty_purple.m2")	(low, swirly fog/smoke)
]]

--SPELLS\\HOLIDAYS\\Valentines_LookingForLoveHeart.m2
--SPELLS\\HOLIDAYS\\Valentines_RoseShower_Impact_Base.m2